unit GrphPrev;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
   Dialogs, ExtCtrls, Printers;

type
  { {Ɣ͈͂̂ǂɈ邩߂l }
  TPrintMode = (pmRatio, pmArea);

  { ɎgpgpOtBbN̎ }
  TGraphicMode = (gmMetafile, gmGraphic);

  TDoubleSize = record
    Width: Double;
    Height: Double;
  end;

  TIntegerSize = record
    Width: Integer;
    Height: Integer;
  end;

  PDoublePoint = ^TDoublePoint;
  TDoublePoint = record
    X: Double;
    Y: Double;
  end;

  PDoubleRect = ^TDoubleRect;
  TDoubleRect = record
    case Integer of
      0: (Left, Top, Right, Bottom: Double);
      1: (TopLeft, BottomRight: TDoublePoint);
  end;

  {  }
  TPaperInfo = record
    PrintableArea: TIntegerSize;      // \̈̃TCY
    MMPrintableArea: TDoubleSize;     // \̈̃TCY(mm)
    PaperSize: TIntegerSize;          // TCY
    MMPaperSize: TDoubleSize;         // TCY(mm)
    DPI: TSize;                       //  DPI l
    SDPI: TSize;                      // XN[ DPI l
    LeftMargin: Integer;              // ]
    TopMargin: Integer;
    RightMargin: Integer;
    BottomMargin: Integer;
    PILeftMargin: Integer;           // ]1C`%l
    PITopMargin: Integer;
    PIRightMargin: Integer;
    PIBottomMargin: Integer;
    MMLeftMargin: Double;             // ](mm)
    MMTopMargin: Double;
    MMRightMargin: Double;
    MMBottomMargin: Double;
    ScaleFactor: Integer;             // XP[t@N^(%)
    MScaleFactor: TSize;              // ^t@C̃XP[t@N^(e%)
    TrueMMPrintableArea: TDoubleSize; // ^̈\̈̃TCY(mm)
    TrueMMPaperSize: TDoubleSize;     // ^̎TCY(mm)
    TrueMMLeftMargin: Double;         // ^̗](mm)
    TrueMMTopMargin: Double;
    TrueMMRightMargin: Double;
    TrueMMBottomMargin: Double;
  end;

type
  { TGraphicPreview NX }
  TGraphicPreview = class(TScrollBox)
  private
    { Private 錾 }
    FPaperInfo: TPaperInfo; // 
    FPicture: TPicture; // Ώۂ̃OtBbÑRei
    FPrintRatio: Integer; // ̔{(%PʁA1 ` 10000)
    FPreviewRatio: Integer; // vr[̔{(% PʁA10 ` 100)
    FPrintMode: TPrintMode; // {Ɣ͈͂̂ǂɈ邩߂l
    FGraphicMode: TGraphicMode; // ɎgpgpOtBbN̎
    FMouseAction: Boolean; // }EXɂĈJnʒuύX
    FPrintPoint: TPoint; // Jnn_(sNZP)
    FMMPrintPoint: TDoublePoint; // Jnn_(mm P)
    FPrintRect: TRect; // ͈(sNZP)
    FMMPrintRect: TDoubleRect; // ͈(mm P)
    FImages: array of TImage; // ey[W̃vr[C[Wi[铮Iz
    FOnPreview: TNotifyEvent;  // OnPreview CxgtB[h
    FOnPreviewed: TNotifyEvent;  // OnPreviewed CxgtB[h
    FMScaleFactor: TSize; // ^t@C̃XN[ł̃XP[t@N^(e%)
    function GetPaperInfo: TPaperInfo;
    function GetImage(X, Y:Integer): TImage;
    function GetGraphic: TGraphic;
    function GetColumn: Integer;
    function GetRow: Integer;
    function GetPrintRatio: Integer;
    function GetPreviewRatio: Integer;
    function GetPrintMode: TPrintMode;
    function GetGraphicMode: TGraphicMode;
    function GetMouseAction: Boolean;
    function GetPrintPoint: TPoint;
    function GetMMPrintPoint: TDoublePoint;
    function GetPrintRect: TRect;
    function GetMMPrintRect: TDoubleRect;
    function GetPageRect(X, Y: Integer): TRect;
    function GetMMPageRect(X, Y: Integer): TDoubleRect;
    function GetRealPageRect(X, Y: Integer): TRect;
    function GetRealMMPageRect(X, Y: Integer): TDoubleRect;
    function GetRealBaseRect(X, Y: Integer): TRect;
    function GetRealMMBaseRect(X, Y: Integer): TDoubleRect;
    function GetImageWidth: Integer;
    function GetImageHeight: Integer;
    function GetPreviewWidth: Integer;
    function GetPreviewHeight: Integer;
    function Pixel2mmPoint(P: TPoint): TDoublePoint; // Pixel l mm lɕϊ
    function Pixel2mmRect(R: TRect): TDoubleRect; // Pixel l mm lɕϊ
    function mm2PixelPoint(P: TDoublePoint): TPoint; //mm l Pixel lɕϊ
    function mm2PixelRect(R: TDoubleRect): TRect; //mm l Pixel lɕϊ
    function GetMScaleFactor: TSize; // ^t@C̃XN[ł̃XP[t@N^擾(e%)
    procedure SetGraphic(const Value: TGraphic);
    procedure SetPrintRatio(const Value: Integer);
    procedure SetPreviewRatio(const Value: Integer);
    procedure SetPrintMode(const Value: TPrintMode);
    procedure SetGraphicMode(const Value: TGraphicMode);
    procedure SetMouseAction(const Value: Boolean);
    procedure SetPrintPoint(const Value: TPoint);
    procedure SetMMPrintPoint(const Value: TDoublePoint);
    procedure SetPrintRect(const Value: TRect);
    procedure SetMMPrintRect(const Value: TDoubleRect);
    procedure CorrectPoint(var P: TPoint); // TPoint ɗlɕ␳
    procedure CorrectRect(var R: TRect); // TRect ̍オɗlɕ␳
    procedure CollectPaperInfo;
    procedure DispPage(X, Y: Integer);
  protected
    { Protected 錾 }
    procedure ClickHandler(Sender: TObject); dynamic;
    procedure DblClickHandler(Sender: TObject); dynamic;
    procedure DragDropHandler(Sender, Source: TObject; X, Y: Integer); dynamic;
    procedure DragOverHandler(Sender, Source: TObject; X, Y: Integer;
     State: TDragState; var Accept: Boolean); dynamic;
    procedure EndDockHandler(Sender, Target: TObject; X, Y: Integer); dynamic;
    procedure EndDragHandler(Sender, Target: TObject; X, Y: Integer); dynamic;
    procedure MouseDownHandler(Sender: TObject; Button: TMouseButton;
     Shift: TShiftState; X, Y: Integer); dynamic;
    procedure MouseMoveHandler(Sender: TObject; Shift: TShiftState;
     X, Y: Integer); dynamic;
    procedure MouseUpHandler(Sender: TObject; Button: TMouseButton;
     Shift: TShiftState; X, Y: Integer); dynamic;
    procedure StartDockHandler(Sender: TObject;
     var DragObject: TDragDockObject); dynamic;
    procedure StartDragHandler(Sender: TObject;
     var DragObject: TDragObject); dynamic;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure DispPages; virtual;
    { Cxg\bh錾 }
    procedure Preview; dynamic;
    procedure Previewed; dynamic;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Repaint; override;
    procedure Clear; virtual;
    procedure DispPaperInfo;
    procedure Print(Books: Integer);
    procedure PrintPage(PageFrom: Integer; PageTo: Integer; Books: Integer);
    function GetPageMeta(X, Y: Integer): TMetafile;
    { vpeB錾 }
    property PaperInfo: TPaperInfo read GetPaperInfo;
    property Column: Integer read GetColumn;
    property Row: Integer read GetRow;
    property ImageWidth: Integer read GetImageWidth;
    property ImageHeight: Integer read GetImageHeight;
    property PreviewWidth: Integer read GetPreviewWidth;
    property PreviewHeight: Integer read GetPreviewHeight;
    property PrintPoint: TPoint read GetPrintPoint write SetPrintPoint;
    property MMPrintPoint: TDoublePoint read GetMMPrintPoint write SetMMPrintPoint;
    property PrintRect: TRect read GetPrintRect write SetPrintRect;
    property MMPrintRect: TDoubleRect read GetMMPrintRect write SetMMPrintRect;
    property PageRect[X, Y: Integer]: TRect read GetPageRect;
    property MMPageRect[X, Y: Integer]: TDoubleRect read GetMMPageRect;
    property RealPageRect[X, Y: Integer]: TRect read GetRealPageRect;
    property RealMMPageRect[X, Y: Integer]: TDoubleRect read GetRealMMPageRect;
    property RealBaseRect[X, Y: Integer]: TRect read GetRealBaseRect;
    property RealMMBaseRect[X, Y: Integer]: TDoubleRect read GetRealMMBaseRect;
    property Images[X, Y: Integer]: TImage read GetImage;
  published
    { Published 錾(vpeB錾) }
    property Graphic: TGraphic read GetGraphic write SetGraphic;
    property PrintRatio: Integer read GetPrintRatio write SetPrintRatio default 100;
    property PreviewRatio: Integer read GetPreviewRatio write SetPreviewRatio default 20;
    property PrintMode: TPrintMode read GetPrintMode write SetPrintMode default pmRatio;
    property GraphicMode: TGraphicMode read GetGraphicMode write SetGraphicMode default gmMetafile;
    property MouseAction: Boolean read GetMouseAction write SetMouseAction default False;
    { Cxg錾 }
    property OnPreview: TNotifyEvent read FOnPreview write FOnPreview;
    property OnPreviewed: TNotifyEvent read FOnPreviewed write FOnPreviewed;
  end;

function DoublePoint(AX, AY: Double): TDoublePoint;
function DoubleRect(ALeft, ATop, ARight, ABottom: Double): TDoubleRect;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('ToolBox', [TGraphicPreview]);
end;

{ TGraphicPreview }

constructor TGraphicPreview.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FPicture := TPicture.Create;
  FPicture.Graphic := Nil;
  FPrintRatio := 100;
  FPreviewRatio := 20;
  CollectPaperInfo; // 擾B
  PrintPoint := Point(0, 0); // ̊_(sNZP)
  GetMScaleFactor; // ^t@C̃XN[ł̃XP[t@N^擾(e%)
end;

destructor TGraphicPreview.Destroy;
var
  i: Integer;
begin
  for i := Length(FImages) downto 1 do
  begin
    FImages[i - 1].Picture := Nil;
    FImages[i - 1].Free;
  end;
  SetLength(FImages, 0);
  FPicture.Free;
  inherited Destroy;
end;

function TGraphicPreview.GetMScaleFactor: TSize;
var
  W, H: Integer;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  FMScaleFactor.cx := 100; // ʏ́A100 %
  FMScaleFactor.cy := 100; // ʏ́A100 %
  // XN[̃TCY擾B
  W := GetDeviceCaps(GetDC(0), HORZRES);
  H := GetDeviceCaps(GetDC(0), VERTRES);
  // ^t@C̃XP[t@N^擾B
  Mf := TMetafile.Create;
  try
    MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
    try
      ;
    finally
      MfCanvas.Free;
    end;
    // ^t@C̃LoX(MfCanvas)j(Free)_ŗ_́A
    // Mf.Width = GetDeviceCaps(GetDC(0), HORZRES); // = Screen.Width
    // Mf.Height = GetDeviceCaps(GetDC(0), VERTRES); // Screen.Height
    // ƂȂȂƂ̂łÂƂ̃XN[̉𑜓x
    // (DPI l)ɂẮAȂȂꍇ܂B
    // MScaleFactor vpeB́AXN[foCXReLXg
    // w肵ă^t@C̃LoX쐬ꍇAۂ̃^t@C
    // ̑傫_̑傫̉ % ɂȂ邩̂łB
    // ʏ́A100 % łB
    // `̑傫XN[foCXɂ悤ɂ܂B(Inch <> 0)
    Mf.Inch := 1;
    FMScaleFactor.cx := Mf.Width * 100 div W;
    FMScaleFactor.cy := Mf.Height * 100 div H;
  finally
    Mf.Free;
  end;
end;

{ SẴvr[C[WNA[葱łB}
{ Graphic NA[܂B}

procedure TGraphicPreview.Clear;
begin
  Graphic := Nil;
end;

{ vr[C[WŃ}EX{^ÃnhĂ΂A}
{ TImage ŋN OnClick Cxg TGraphicPreview ̃Cxg }
{ Ƃ܂B}

procedure TGraphicPreview.ClickHandler(Sender: TObject);
begin
  { TGraphicPreview   OnClick Cxg𔭐܂B}
  Click;
end;

{ 擾āAFPaperInfo Ɋi[葱 }

procedure TGraphicPreview.CollectPaperInfo;
var
  Device, Driver, Port: array[0..512] of Char;
  hDev: THandle;     // DevMode ̃nh
  pDev: PDEVICEMODE; // DevMode ւ̃|C^
  PI: Integer;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  // XN[ DPI l擾B
  FPaperInfo.SDPI.cx := GetDeviceCaps(GetDC(0), LOGPIXELSX);
  FPaperInfo.SDPI.cy := GetDeviceCaps(GetDC(0), LOGPIXELSY);

  //  DPI l擾B
  FPaperInfo.DPI.cx := GetDeviceCaps(Printer.Handle, LOGPIXELSX);
  FPaperInfo.DPI.cy := GetDeviceCaps(Printer.Handle, LOGPIXELSY);

  // \̈擾B
  FPaperInfo.PrintableArea.Width := GetDeviceCaps(Printer.Handle, HORZRES);
  FPaperInfo.PrintableArea.Height := GetDeviceCaps(Printer.Handle, VERTRES);
  FPaperInfo.MMPrintableArea.Width := FPaperInfo.PrintableArea.Width / FPaperInfo.DPI.cx * 25.4;
  FPaperInfo.MMPrintableArea.Height := FPaperInfo.PrintableArea.Height / FPaperInfo.DPI.cy * 25.4;

  // TCY擾B
  FPaperInfo.PaperSize.Width := GetDeviceCaps(Printer.Handle, PHYSICALWIDTH);
  FPaperInfo.PaperSize.Height := GetDeviceCaps(Printer.Handle, PHYSICALHEIGHT);
  FPaperInfo.MMPaperSize.Width := FPaperInfo.PaperSIze.Width / FPaperInfo.DPI.cx * 25.4;
  FPaperInfo.MMPaperSize.Height := FPaperInfo.PaperSIze.Height / FPaperInfo.DPI.cy * 25.4;

  // ]擾AvZB
  FPaperInfo.LeftMargin := GetDeviceCaps(Printer.Handle, PHYSICALOFFSETX);
  FPaperInfo.TopMargin := GetDeviceCaps(Printer.Handle, PHYSICALOFFSETY);
  FPaperInfo.RightMargin := FPaperInfo.PaperSize.Width - FPaperInfo.PrintableArea.Width - FPaperInfo.LeftMargin;
  FPaperInfo.BottomMargin := FPaperInfo.PaperSize.Height - FPaperInfo.PrintableArea.Height - FPaperInfo.TopMargin;

  // ]1C`%l
  // ̒l菬l]ƂĐݒ肷鎖́Ao܂B
  PI := FPaperInfo.LeftMargin * 100;
  if (PI mod FPaperInfo.DPI.cx) = 0 then
    PI := PI div FPaperInfo.DPI.cx
  else
    PI := PI div FPaperInfo.DPI.cx + 1;
  FPaperInfo.PILeftMargin := PI;
  PI := FPaperInfo.TopMargin * 100;
  if (PI mod FPaperInfo.DPI.cy) = 0 then
    PI := PI div FPaperInfo.DPI.cy
  else
    PI := PI div FPaperInfo.DPI.cy + 1;
  FPaperInfo.PITopMargin := PI;
  PI := FPaperInfo.RightMargin * 100;
  if (PI mod FPaperInfo.DPI.cx) = 0 then
    PI := PI div FPaperInfo.DPI.cx
  else
    PI := PI div FPaperInfo.DPI.cx + 1;
  FPaperInfo.PIRightMargin := PI;
  PI := FPaperInfo.BottomMargin * 100;
  if (PI mod FPaperInfo.DPI.cy) = 0 then
    PI := PI div FPaperInfo.DPI.cy
  else
    PI := PI div FPaperInfo.DPI.cy + 1;
  FPaperInfo.PIBottomMargin := PI;
  FPaperInfo.MMLeftMargin := FPaperInfo.LeftMargin / FPaperInfo.DPI.cx * 25.4;
  FPaperInfo.MMTopMargin :=  FPaperInfo.TopMargin / FPaperInfo.DPI.cy * 25.4;
  FPaperInfo.MMRightMargin := FPaperInfo.RightMargin / FPaperInfo.DPI.cx * 25.4;
  FPaperInfo.MMBottomMargin :=  FPaperInfo.BottomMargin / FPaperInfo.DPI.cy * 25.4;

  // XP[t@N^擾B
  Printer.GetPrinter(Device, Driver, Port, hDev);
  pDev := GlobalLock(hDev);
  try
    if (pDev.dmFields and DM_SCALE) <> 0 then
      FPaperInfo.ScaleFactor := pDev.dmScale
    else
      FPaperInfo.ScaleFactor := 100;
  finally
    GlobalUnlock(hDev);
  end;

  // ^t@C̃XP[t@N^擾B
  Mf := TMetafile.Create;
  try
    MfCanvas := TMetafileCanvas.Create(Mf, Printer.Handle);
    try
      ;
    finally
      MfCanvas.Free;
    end;
    // ^t@C̃LoX(MfCanvas)j(Free)_ŗ_́A
    // Mf.Width = FPaperInfo.PrintableArea.Width
    // Mf.Height = FPaperInfo.PrintableArea.Height
    // ƂȂȂƂ̂łÂƂ̃v^̉𑜓x
    // (DPI l)ɂẮAȂȂꍇ܂B
    // TPaperInfo  MScaleFactor óAv^foCXReLXg
    // Ɏw肵ă^t@C̃LoX쐬ꍇAۂ̃^t@C
    // ̑傫_̑傫̉ % ɂȂ邩̂łB
    // ʏ́A100 % łB
    FPaperInfo.MScaleFactor.cx := Mf.Width * 100 div
                                   FPaperInfo.PrintableArea.Width;
    FPaperInfo.MScaleFactor.cy := Mf.Height * 100 div
                                   FPaperInfo.PrintableArea.Height;
  finally
    Mf.Free;
  end;

  FPaperInfo.TrueMMPrintableArea.Width := FPaperInfo.MMPrintableArea.Width * FPaperInfo.ScaleFactor / 100;
  FPaperInfo.TrueMMPrintableArea.Height := FPaperInfo.MMPrintableArea.Height * FPaperInfo.ScaleFactor / 100;
  FPaperInfo.TrueMMPaperSize.Width := FPaperInfo.MMPaperSize.Width * FPaperInfo.ScaleFactor / 100;
  FPaperInfo.TrueMMPaperSize.Height := FPaperInfo.MMPaperSize.Height * FPaperInfo.ScaleFactor / 100;
  FPaperInfo.TrueMMLeftMargin := FPaperInfo.MMLeftMargin * FPaperInfo.ScaleFactor / 100;
  FPaperInfo.TrueMMTopMargin := FPaperInfo.MMTopMargin * FPaperInfo.ScaleFactor / 100;
  FPaperInfo.TrueMMRightMargin := FPaperInfo.MMRightMargin * FPaperInfo.ScaleFactor / 100;
  FPaperInfo.TrueMMBottomMargin := FPaperInfo.MMBottomMargin * FPaperInfo.ScaleFactor / 100;
end;

{ ^ꂽ TPoint ɂȂꍇɁAɗl }
{ ␳葱łB }

procedure TGraphicPreview.CorrectPoint(var P: TPoint);
var
  PP: TPoint;
  W, H: Integer;
  n: Integer;
begin
  PP := P;
  W := FPaperInfo.PrintableArea.Width;
  H := FPaperInfo.PrintableArea.Height;

  if PP.X < 0 then
  begin
    n := -PP.X div W;
    if (-PP.X mod W) <> 0 then
      Inc(n);
    PP.X := PP.X + W * n;
  end
  else if PP.X > W - 1 then
  begin
    n := (PP.X - W + 1) div W;
    if ((PP.X - W + 1) mod W) <> 0 then
      Inc(n);
    PP.X := PP.X - W * n;
  end;

  if PP.Y < 0 then
  begin
    n := -PP.Y div H;
    if (-PP.Y mod H) <> 0 then
      Inc(n);
    PP.Y := PP.Y + H * n;
  end
  else if PP.Y > H - 1 then
  begin
    n := (PP.Y - H + 1) div H;
    if ((PP.Y - H + 1) mod H) <> 0 then
      Inc(n);
    PP.Y := PP.Y - H * n;
  end;

  P := PP
end;

{ ^ꂽ TRect ̍(Left, Top)ɂȂꍇɁAɗl }
{ ␳葱łB }

procedure TGraphicPreview.CorrectRect(var R: TRect);
var
  RR: TRect;
  W, H: Integer;
  n: Integer;
begin
  RR := R;
  W := FPaperInfo.PrintableArea.Width;
  H := FPaperInfo.PrintableArea.Height;

  if RR.Left < 0 then
  begin
    n := -RR.Left div W;
    if (-RR.Left mod W) <> 0 then
      Inc(n);
    RR.Left := RR.Left + W * n;
    RR.Right := RR.Right + W * n;
  end
  else if RR.Left > W - 1 then
  begin
    n := (RR.Left - W + 1) div W;
    if ((RR.Left - W + 1) mod W) <> 0 then
      Inc(n);
    RR.Left := RR.Left - W * n;
    RR.Right := RR.Right - W * n;
  end;

  if RR.Top < 0 then
  begin
    n := -RR.Top div H;
    if (-RR.Top mod H) <> 0 then
      Inc(n);
    RR.Top := RR.Top + H * n;
    RR.Bottom := RR.Bottom + H * n;
  end
  else if RR.Top > H - 1 then
  begin
    n := (RR.Top - H + 1) div H;
    if ((RR.Top - H + 1) mod H) <> 0 then
      Inc(n);
    RR.Top := RR.Top - H * n;
    RR.Bottom := RR.Bottom - H * n;
  end;

  R := RR;
end;

{ vr[C[WŃ}EX{^ÃnhĂ΂A}
{ TImage ŋN OnDblClick Cxg TGraphicPreview ̃Cxg }
{ Ƃ܂B}

procedure TGraphicPreview.DblClickHandler(Sender: TObject);
begin
  { TGraphicPreview   OnDblClick Cxg𔭐܂B}
  DblClick;
end;

{ Y sAX ڂ̃y[W Graphic ^t@C` Images[X, Y]  }
{ \葱łBImages[X, Y] ݂Ȃꍇ́AVō쐬 }
{ ܂B̎葱́ADispPages Ăяo܂B}

procedure TGraphicPreview.DispPage(X, Y:Integer);
var
  i: Integer;
  W, H: Integer;
  Mf: TMetafile;
  PMf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  if (X < 1) or (X > Column)
   or (Y < 1) or (Y > Row) then
    Exit;

  // Y s X ڂ̃C[W̃CfbNXԍ(1 ` Row * Column)
  i := (Y - 1) * Column + X;
  if i = 1 then
  begin
    W := 0;
    H := 0;
  end
  else
  begin
      W := FImages[0].Width;
      H := FImages[0].Height;
  end;

  if Length(FImages) < i then // FImages[i - 1] 쐬B(= Images[X, Y])
  begin
    SetLength(FImages, i);
    FImages[i - 1] := TImage.Create(Self);
    FImages[i - 1].Parent := Self;
    FImages[i - 1].AutoSize := True;
    { eCxgnh̃A^b` }
    FImages[i - 1].OnClick := ClickHandler;
    FImages[i - 1].OnDblClick := DblClickHandler;
    FImages[i - 1].OnDragDrop := DragDropHandler;
    FImages[i - 1].OnDragOver := DragOverHandler;
    FImages[i - 1].OnEndDock := EndDockHandler;
    FImages[i - 1].OnEndDrag := EndDragHandler;
    FImages[i - 1].OnMouseDown := MouseDownHandler;
    FImages[i - 1].OnMouseMove := MouseMoveHandler;
    FImages[i - 1].OnMouseUp := MouseUpHandler;
    FImages[i - 1].OnStartDock := StartDockHandler;
    FImages[i - 1].OnStartDrag := StartDragHandler;
  end;
  FImages[i - 1].Picture := Nil;
  FImages[i - 1].Left := (X - 1) * W;
  FImages[i - 1].Top := (Y - 1) * H;

  Mf := TMetafile.Create;
  try
    { 傫ڂ̃^t@CB}
    Mf.Width := (FPaperInfo.PaperSize.Width + 150)
                * 100 div FPaperInfo.MScaleFactor.cx;
    Mf.Height := (FPaperInfo.PaperSize.Height + 150)
                 * 100 div FPaperInfo.MScaleFactor.cy;
    MfCanvas := TMetafileCanvas.Create(Mf, Printer.Handle);
    try
      { \̈Ƀy[WC[W`B}
      PMf := GetPageMeta(X, Y); // Y sAX ڂ̃y[W̃^t@CC[W
      try
        MfCanvas.Draw(FPaperInfo.LeftMargin + 50, FPaperInfo.TopMargin + 50,
                      PMf);
      finally
        PMf.Free;
      end;

      { ̗]`B}
      MfCanvas.Pen.Color := clWhite;
      MfCanvas.Brush.Color := clWhite;
      MfCanvas.FillRect(Rect(0,
                             0,
                             FPaperInfo.PaperSize.Width + 150,
                             FPaperInfo.TopMargin + 50));
      MfCanvas.FillRect(Rect(0,
                             FPaperInfo.TopMargin + 50 + FPaperInfo.PrintableArea.Height,
                             FPaperInfo.PaperSize.Width + 150,
                             FPaperInfo.PaperSize.Height + 150));
      MfCanvas.FillRect(Rect(0,
                             FPaperInfo.TopMargin + 50,
                             FPaperInfo.LeftMargin + 50,
                             FPaperInfo.TopMargin + 50 + FPaperInfo.PrintableArea.Height));
      MfCanvas.FillRect(Rect(FPaperInfo.LeftMargin + 50 + FPaperInfo.PrintableArea.Width,
                             FPaperInfo.TopMargin + 50,
                             FPaperInfo.PaperSize.Width + 150,
                             FPaperInfo.TopMargin + 50 + FPaperInfo.PrintableArea.Height));

      { ̔wi`B}
      MfCanvas.Pen.Color := clBtnFace;
      MfCanvas.Brush.Color := clBtnFace;
      MfCanvas.FillRect(Rect(0,
                             0,
                             FPaperInfo.PaperSize.Width + 150,
                             50));
      MfCanvas.FillRect(Rect(0,
                             FPaperInfo.PaperSize.Height + 50,
                             FPaperInfo.PaperSize.Width + 150,
                             FPaperInfo.PaperSize.Height + 150));
      MfCanvas.FillRect(Rect(0,
                             50,
                             50,
                             FPaperInfo.PaperSize.Height + 50));
      MfCanvas.FillRect(Rect(FPaperInfo.PaperSize.Width + 50,
                             50,
                             FPaperInfo.PaperSize.Width + 150,
                             FPaperInfo.PaperSize.Height + 50));

      { ̃hbvVhE`B}
      MfCanvas.Pen.Color := clDkGray;
      MfCanvas.Brush.Color := clDkGray;
      MfCanvas.FillRect(Rect(100,
                             FPaperInfo.PaperSize.Height + 50,
                             FPaperInfo.PaperSize.Width + 100,
                             FPaperInfo.PaperSize.Height + 100));
      MfCanvas.FillRect(Rect(FPaperInfo.PaperSize.Width + 50,
                             100,
                             FPaperInfo.PaperSize.Width + 100,
                             FPaperInfo.PaperSize.Height + 50));

      { ̗̈`B}
      MfCanvas.Pen.Style := psSolid;
      MfCanvas.Pen.Color := clBlack;
      MfCanvas.MoveTo(50, 50);
      MfCanvas.LineTo(FPaperInfo.PaperSize.Width + 50,
                      50);
      MfCanvas.LineTo(FPaperInfo.PaperSize.Width + 50,
                      FPaperInfo.PaperSize.Height + 50);
      MfCanvas.LineTo(50,
                      FPaperInfo.PaperSize.Height + 50);
      MfCanvas.LineTo(50,
                      50);

      { \̈`B}
      MfCanvas.Pen.Style := psDot;
      MfCanvas.MoveTo(FPaperInfo.LeftMargin + 50, FPaperInfo.TopMargin + 50);
      MfCanvas.LineTo(FPaperInfo.LeftMargin + 50 + FPaperInfo.PrintableArea.Width,
                      FPaperInfo.TopMargin + 50);
      MfCanvas.LineTo(FPaperInfo.LeftMargin + 50 + FPaperInfo.PrintableArea.Width,
                      FPaperInfo.TopMargin + 50 + FPaperInfo.PrintableArea.Height);
      MfCanvas.LineTo(FPaperInfo.LeftMargin + 50,
                      FPaperInfo.TopMargin + 50 + FPaperInfo.PrintableArea.Height);
      MfCanvas.LineTo(FPaperInfo.LeftMargin + 50,
                      FPaperInfo.TopMargin + 50);
      MfCanvas.Pen.Style := psSolid;
    finally
      MfCanvas.Free; // JĂ͂߂ăvr[C[W\B
    end;
    { `̑傫XN[foCXɂ悤ɂB(Inch <> 0) }
    Mf.Inch := 1;
    { `TCYwɍ킹B}
    Mf.Width := Mf.Width * FPaperInfo.MScaleFactor.cx div 100
                * FPreviewRatio div 100;
    Mf.Height := Mf.Height * FPaperInfo.MScaleFactor.cy div 100
                 * FPreviewRatio div 100;
    FImages[i - 1].Picture.Graphic := Mf;
  finally
    Mf.Free;
  end;
end;

{ Graphic ̃vr[C[W\葱łB}
{ (Row s ~ Column ) }

procedure TGraphicPreview.DispPages;
var
  i: Integer;
  X, Y: Integer;
begin
  Preview;    // OnPreview CxgŔ
  Cursor := crHourglass;

  { ]ȃC[W΍폜ĂB}
  for i := Length(FImages) downto Row * Column + 1 do
  begin
    FImages[i - 1].Picture := Nil;
    FImages[i - 1].Free;
    SetLength(FImages, i - 1);
  end;

  if (FPicture.Graphic <> Nil) and (not (csDesigning in ComponentState)) then
  begin
    VertScrollBar.Position := 0;
    HorzScrollBar.Position := 0;
  end;

  for Y := 1 to Row do
  begin
    for X := 1 to Column do
      DispPage(X, Y);
  end;

  Cursor := crDefault;
  Previewed;    // OnPreviewed CxgŔ
end;

{ \葱łB}

procedure TGraphicPreview.DispPaperInfo;
var
  d1, d2, d3, d4: Double;
  Y: Integer;
  S: String;
  LeftMargin: Integer;
  RightMargin: Integer;
  TopMargin: Integer;
  BottomMargin: Integer;
  TrueMMLeftMargin: Double;
  TrueMMRightMargin: Double;
  TrueMMTopMargin: Double;
  TrueMMBottomMargin: Double;
  TextRect: TRect;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
  W1, W2, H1, H2: Integer;
begin
  CollectPaperInfo; // ݂̎߂B

  { ł̎ۂ̈̈߂B}
  { ܂]̌ݒlsNZɊZB}
  LeftMargin := FPaperInfo.LeftMargin;
  TopMargin := FPaperInfo.TopMargin;
  RightMargin := FPaperInfo.RightMargin;
  BottomMargin := FPaperInfo.BottomMargin;
  { ] mm ɊZB}
  TrueMMLeftMargin := FPaperInfo.TrueMMLeftMargin;
  TrueMMTopMargin := FPaperInfo.TrueMMTopMargin;
  TrueMMRightMargin := FPaperInfo.TrueMMRightMargin;
  TrueMMBottomMargin := FPaperInfo.TrueMMBottomMargin;
  { eLXg`̈̑傫vZB}
  TextRect := Rect(0, 0,
                   FPaperInfo.PaperSize.Width - LeftMargin - RightMargin,
                   FPaperInfo.PaperSize.Height - TopMargin - BottomMargin);
  { eLXg̊JnʒuA(0, 0) ̍WŁA]A]m }
  { 悤ɕ␳B}
  OffsetRect(TextRect, LeftMargin, TopMargin);

  Mf := TMetafile.Create;
  try
    { \̈̃TCỸ^t@CB}
    Mf.Width := FPaperInfo.PrintableArea.Width
                * 100 div FPaperInfo.MScaleFactor.cx;
    Mf.Height := FPaperInfo.PrintableArea.Height
                 * 100 div FPaperInfo.MScaleFactor.cy;
    MfCanvas := TMetafileCanvas.Create(Mf, Printer.Handle);
    try
      { ̗ł̃eLXg̍ƕ߂B}
      MfCanvas.Font.PixelsPerInch := GetDeviceCaps(Printer.Handle, LOGPIXELSY);
      MfCanvas.Font.Assign(Printer.Canvas.Font);
      MfCanvas.Font.Size := 12; // tHg̃TCY 12 ɌŒ肵ĂB
      W1 := MfCanvas.TextWidth('ABCDEFGHIJ');
      H1 := MfCanvas.TextHeight('ABCDEFGHIJ');
      W2 := MfCanvas.TextWidth('̗K');
      H2 := MfCanvas.TextHeight('̗K');

      Y := H2 * 2;
      S := '    '; MfCanvas.TextOut(0, Y, S); Y := Y + H2 * 2;
      S := '    \̈̃TCY'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %d~%d pixel', [FPaperInfo.PrintableArea.Width,
                  FPaperInfo.PrintableArea.Height]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %f~%f mm', [FPaperInfo.TrueMMPrintableArea.Width,
                  FPaperInfo.TrueMMPrintableArea.Height]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    DPI l'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %d~%d dot per inch', [FPaperInfo.DPI.cx, FPaperInfo.DPI.cy]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    ʂ DPI l'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %d~%d dot per inch', [FPaperInfo.SDPI.cx, FPaperInfo.SDPI.cy]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    XP[t@N^'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %d %%', [FPaperInfo.ScaleFactor]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    ^t@C̃XP[t@N^'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %d~%d %%', [FPaperInfo.MScaleFactor.cx, FPaperInfo.MScaleFactor.cy]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    TCY'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %d~%d pixel', [FPaperInfo.PaperSize.Width,
                  FPaperInfo.PaperSize.Height]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %f~%f mm', [FPaperInfo.TrueMMPaperSize.Width,
                  FPaperInfo.TrueMMPaperSize.Height]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    ʂ̃TCY'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %d~%d pixel', [Screen.Width, Screen.Height]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %f~%f mm', [Screen.Width * 25.4 / FPaperInfo.SDPI.cx,
                  Screen.Height * 25.4 / FPaperInfo.SDPI.cy]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    ], ]'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %d, %d pixel', [LeftMargin, TopMargin]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %f, %f mm', [TrueMMLeftMargin,
                  TrueMMTopMargin]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    E], ]'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %d, %d pixel', [RightMargin, BottomMargin]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %f, %f mm', [TrueMMRightMargin,
                  TrueMMBottomMargin]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    ł̎ۂ̈̈(Left, Top, Right, Bottom)'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      (%d, %d, %d, %d) pixel', [TextRect.Left, TextRect.Top,
                  TextRect.Right, TextRect.Bottom]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      d1 := TextRect.Left * 25.4 / FPaperInfo.DPI.cx * FPaperInfo.ScaleFactor / 100;
      d2 := TextRect.Top * 25.4 / FPaperInfo.DPI.cy * FPaperInfo.ScaleFactor / 100;
      d3 := TextRect.Right * 25.4 / FPaperInfo.DPI.cx * FPaperInfo.ScaleFactor / 100;
      d4 := TextRect.Bottom * 25.4 / FPaperInfo.DPI.cy * FPaperInfo.ScaleFactor / 100;
      S := Format('      (%f, %f, %f, %f) mm', [d1, d2, d3, d4]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    tHg'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '      ' + MfCanvas.Font.Name; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    tHgTCY'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %d point', [MfCanvas.Font.Size]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      d1 := MfCanvas.Font.Size * FPaperInfo.DPI.cy / 72;
      S := Format('      %f pixel', [d1]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      d1 := MfCanvas.Font.Size * 25.4 / 72 * FPaperInfo.ScaleFactor / 100;
      S := Format('      %f mm', [d1]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    tHg̍'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %d', [MfCanvas.Font.Height]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    eLXg̍(  :uABCDEFGHIJv,u̗Kv)'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %d, %d pixel', [H1, H2]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      d1 := H1 * 25.4 / FPaperInfo.DPI.cy * FPaperInfo.ScaleFactor / 100;
      d2 := H2 * 25.4 / FPaperInfo.DPI.cy * FPaperInfo.ScaleFactor / 100;
      S := Format('      %f, %f mm', [d1, d2]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    eLXg̕(  :uABCDEFGHIJv,u̗Kv)'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := Format('      %d, %d pixel', [W1, W2]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      d1 := W1 * 25.4 / FPaperInfo.DPI.cx * FPaperInfo.ScaleFactor / 100;
      d2 := W2 * 25.4 / FPaperInfo.DPI.cx * FPaperInfo.ScaleFactor / 100;
      S := Format('      %f, %f mm', [d1, d2]); MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '    Ql'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '      1 point = 1/72 inch'; MfCanvas.TextOut(0, Y, S); Y := Y + H2;
      S := '      1 inch = 25.4 mm'; MfCanvas.TextOut(0, Y, S);

    finally
      MfCanvas.Free; // JĂ͂߂ĕ\B
    end;
    { `̑傫XN[foCXɂ悤ɂB(Inch <> 0) }
    Mf.Inch := 1;
    Mf.Width := Mf.Width * FPaperInfo.MScaleFactor.cx div 100;
    Mf.Height := Mf.Height * FPaperInfo.MScaleFactor.cy div 100;
    Graphic := Mf; // \B
  finally
    Mf.Free;
  end;
end;

{ DoublePoint ́ADouble ^̍W TDoublePoint \̂쐬 }
{ Ԃėp̊֐łB}

function DoublePoint(AX, AY: Double): TDoublePoint;
begin
  Result.X := AX;
  Result.Y := AY;
end;

{ DoubleRect ́ADouble ^̍W̑gݍ킹 TDoubleRect \̂쐬 }
{ Ԃėp̊֐łB}

function DoubleRect(ALeft, ATop, ARight, ABottom: Double): TDoubleRect;
begin
  Result.Left := ALeft;
  Result.Top := ATop;
  Result.Right := ARight;
  Result.Bottom := ABottom;
end;

{ vr[C[WŃ}EX{^ÃnhĂ΂A}
{ TImage ŋN OnDragDrop Cxg TGraphicPreview ̃Cxg }
{ Ƃ܂B}

procedure TGraphicPreview.DragDropHandler(Sender, Source: TObject; X, Y: Integer);
begin
  { TImage ̍W TGraphicPreview ̍Wɕϊ܂B}
  X := TImage(Sender).Left + X;
  Y := TImage(Sender).Top + Y;
  { TGraphicPreview   OnDragDrop Cxg𔭐܂B}
  DragDrop(Source, X, Y);
end;

{ vr[C[WŃ}EX{^ÃnhĂ΂A}
{ TImage ŋN OnDragOver Cxg TGraphicPreview ̃Cxg }
{ Ƃ܂B}

procedure TGraphicPreview.DragOverHandler(Sender, Source: TObject; X, Y: Integer;
 State: TDragState; var Accept: Boolean);
begin
  { TImage ̍W TGraphicPreview ̍Wɕϊ܂B}
  X := TImage(Sender).Left + X;
  Y := TImage(Sender).Top + Y;
  { TGraphicPreview   OnDragOver Cxg𔭐܂B}
  DragOver(Source, X, Y, State, Accept);
end;

{ vr[C[WŃ}EX{^ÃnhĂ΂A}
{ TImage ŋN OnEndDock Cxg TGraphicPreview ̃Cxg }
{ Ƃ܂B}

procedure TGraphicPreview.EndDockHandler(Sender, Target: TObject; X, Y: Integer);
begin
  { TImage ̍W TGraphicPreview ̍Wɕϊ܂B}
  X := TImage(Sender).Left + X;
  Y := TImage(Sender).Top + Y;
  { TGraphicPreview   OnEndDock Cxg𔭐܂B}
  DoEndDock(Target, X, Y);
end;

{ vr[C[WŃ}EX{^ÃnhĂ΂A}
{ TImage ŋN OnEndDrag Cxg TGraphicPreview ̃Cxg }
{ Ƃ܂B}

procedure TGraphicPreview.EndDragHandler(Sender, Target: TObject; X, Y: Integer);
begin
  { TImage ̍W TGraphicPreview ̍Wɕϊ܂B}
  X := TImage(Sender).Left + X;
  Y := TImage(Sender).Top + Y;
  { TGraphicPreview   OnEndDrag Cxg𔭐܂B}
  DoEndDrag(Target, X, Y);
end;

{ ̖̉̎(ő16) }

function TGraphicPreview.GetColumn: Integer;
var
  RW, AW: Integer;
begin
  Result := 0;
  if FPicture.Graphic = Nil then
    Exit;

  RW := FPrintRect.Right;
  AW := FPaperInfo.PrintableArea.Width;

  Result := RW div AW;
  if (RW mod AW) <> 0 then
    Inc(Result);
  if Result > 16 then
    Result := 16;
end;

function TGraphicPreview.GetGraphic: TGraphic;
begin
  Result := FPicture.Graphic;
end;

function TGraphicPreview.GetGraphicMode: TGraphicMode;
begin
  Result := FGraphicMode;
end;

function TGraphicPreview.GetImage(X, Y:Integer): TImage;
begin
  if (X < 1) or (X > Column) then
    raise ERangeError.CreateFmt('%d is not within the valid range of %d..%d',
     [X, 1, Column])
  else if (Y < 1) or (Y > Row) then
    raise ERangeError.CreateFmt('%d is not within the valid range of %d..%d',
     [Y, 1, Row]);

  Result := FImages[(Y - 1) * Column + X - 1]; // Y s X ڂ̃C[W
end;

function TGraphicPreview.GetImageHeight: Integer;
begin
  Result := (FPaperInfo.PaperSize.Height + 150) div FPaperInfo.DPI.cy
             * FPaperInfo.SDPI.cy  * FPreviewRatio div 100;
end;

function TGraphicPreview.GetImageWidth: Integer;
begin
  Result := (FPaperInfo.PaperSize.Width + 150) div FPaperInfo.DPI.cx
             * FPaperInfo.SDPI.cx * FPreviewRatio div 100;
end;

{ ɂȂꍇ Y s X ڂ̃y[W猩 MMPrintRect }
{ ̑ΓIȔ͈(mm P) }

function TGraphicPreview.GetMMPageRect(X, Y: Integer): TDoubleRect;
begin
  if (X < 1) or (X > Column) then
    raise ERangeError.CreateFmt('%d is not within the valid range of %d..%d',
     [X, 1, Column])
  else if (Y < 1) or (Y > Row) then
    raise ERangeError.CreateFmt('%d is not within the valid range of %d..%d',
     [Y, 1, Row]);

  Result := MMPrintRect; // Base rect to start printing under mm scale.
  Result.Left := Result.Left - (X - 1) * FPaperInfo.TrueMMPrintableArea.Width;
  Result.Top := Result.Top - (Y - 1) * FPaperInfo.TrueMMPrintableArea.Height;
  Result.Right := Result.Right - (X - 1) * FPaperInfo.TrueMMPrintableArea.Width;
  Result.Bottom := Result.Bottom - (Y - 1) * FPaperInfo.TrueMMPrintableArea.Height;
end;

function TGraphicPreview.GetMMPrintPoint: TDoublePoint;
begin
  Result := FMMPrintPoint;
end;

function TGraphicPreview.GetMMPrintRect: TDoubleRect;
begin
  Result := FMMPrintRect;
end;

function TGraphicPreview.GetMouseAction: Boolean;
begin
  Result := FMouseAction;
end;

{ Graphic ̈ Y sAX ڂ̃^t@CC[WԂ֐łB}

function TGraphicPreview.GetPageMeta(X, Y: Integer): TMetafile;
var
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  Result := Nil;
  if (X < 1) or (X > Column) or (Y < 1) or (Y > Row) then
    Exit;

  Mf := TMetafile.Create;
  { ̑傫̃^t@CB}
  Mf.Width := FPaperInfo.PrintableArea.Width
              * 100 div FPaperInfo.MScaleFactor.cx;
  Mf.Height := FPaperInfo.PrintableArea.Height
              * 100 div FPaperInfo.MScaleFactor.cy;
  MfCanvas := TMetafileCanvas.Create(Mf, Printer.Handle);
  try
    { `B}
    MfCanvas.Pen.Color := clWhite;
    MfCanvas.Brush.Color := clWhite;
    MfCanvas.Rectangle(0, 0,
                       FPaperInfo.PrintableArea.Width,
                       FPaperInfo.PrintableArea.Height);
    { `悷B}
    MfCanvas.StretchDraw(PageRect[X, Y], FPicture.Graphic);
  finally
    MfCanvas.Free; // JĂ͂߂ăvr[C[W\B
  end;
  Result := Mf;
end;

{ ɂȂꍇ Y s X ڂ̃y[W猩 PrintRect }
{ ̑ΓIȔ͈(Pixel P) }

function TGraphicPreview.GetPageRect(X, Y: Integer): TRect;
begin
  if (X < 1) or (X > Column) then
    raise ERangeError.CreateFmt('%d is not within the valid range of %d..%d',
     [X, 1, Column])
  else if (Y < 1) or (Y > Row) then
    raise ERangeError.CreateFmt('%d is not within the valid range of %d..%d',
     [Y, 1, Row]);

  Result := PrintRect; // Base rect to start printing under pixel unit.
  Result.Left := Result.Left - (X - 1) * FPaperInfo.PrintableArea.Width;
  Result.Top := Result.Top - (Y - 1) * FPaperInfo.PrintableArea.Height;
  Result.Right := Result.Right - (X - 1) * FPaperInfo.PrintableArea.Width;
  Result.Bottom := Result.Bottom - (Y - 1) * FPaperInfo.PrintableArea.Height;
end;

function TGraphicPreview.GetPaperInfo: TPaperInfo;
begin
  Result := FPaperInfo;
end;

function TGraphicPreview.GetPreviewHeight: Integer;
begin
  Result := ImageHeight * Row;
end;

function TGraphicPreview.GetPreviewWidth: Integer;
begin
  Result := ImageWidth * Column;
end;

function TGraphicPreview.GetPreviewRatio: Integer;
begin
  Result := FPreviewRatio;
end;

function TGraphicPreview.GetPrintMode: TPrintMode;
begin
  Result := FPrintMode;
end;

function TGraphicPreview.GetPrintPoint: TPoint;
begin
  Result := FPrintPoint;
end;

function TGraphicPreview.GetPrintRatio: Integer;
begin
  Result := FPrintRatio;
end;

function TGraphicPreview.GetPrintRect: TRect;
begin
  Result := FPrintRect;
end;

{ ɂȂꍇ Y s X ڂ̃y[W̎ۂɈ͈͂ }
{ PrintRect ̑ΓI͈͂Ƃĕ\킵(Pixel P) }
{ (= RealPageRect[X, Y]  PrintRect ̑ΓI͈͂Ƃĕ\킵) }

function TGraphicPreview.GetRealBaseRect(X, Y: Integer): TRect;
var
  R: TRect;
begin
  R := PageRect[X, Y];
  Result := RealPageRect[X, Y];
  Result.Left := Result.Left - R.Left;
  Result.Top := Result.Top - R.Top;
  Result.Right := Result.Right - R.Left;
  Result.Bottom := Result.Bottom - R.Top;
end;

{ ɂȂꍇ Y s X ڂ̃y[W̎ۂɈ͈͂ }
{ MMPrintRect ̑ΓI͈͂Ƃĕ\킵(mm P) }
{ (= RealMMPageRect[X, Y]  MMPrintRect ̑ΓI͈͂Ƃĕ\킵) }

function TGraphicPreview.GetRealMMBaseRect(X, Y: Integer): TDoubleRect;
begin
  Result := Pixel2mmRect(RealBaseRect[X, Y])
end;

{ ɂȂꍇ Y s X ڂ̃y[W̎ۂɈ͈(mm P) }
{ (= MMPageRect[X, Y] ̎ۂɈ͈) }

function TGraphicPreview.GetRealMMPageRect(X, Y: Integer): TDoubleRect;
begin
  Result := Pixel2mmRect(RealPageRect[X, Y])
end;

{ ɂȂꍇ Y s X ڂ̃y[W̎ۂɈ͈(Pixel P) }
{ (= PageRect[X, Y] ̎ۂɈ͈) }

function TGraphicPreview.GetRealPageRect(X, Y: Integer): TRect;
begin
  Result := PageRect[X, Y];
  if Result.Left < 0 then
    Result.Left := 0;
  if Result.Top < 0 then
    Result.Top := 0;
  if Result.Right > FPaperInfo.PrintableArea.Width - 1 then
    Result.Right := FPaperInfo.PrintableArea.Width - 1;
  if Result.Bottom > FPaperInfo.PrintableArea.Height - 1 then
    Result.Bottom := FPaperInfo.PrintableArea.Height - 1;
end;

{ ̏c̖̎(ő16) }

function TGraphicPreview.GetRow: Integer;
var
  RH, AH: Integer;
begin
  Result := 0;
  if FPicture.Graphic = Nil then
    Exit;

  RH := FPrintRect.Bottom;
  AH := FPaperInfo.PrintableArea.Height;

  Result := RH div AH;
  if (RH mod AH) <> 0 then
    Inc(Result);
  if Result > 16 then
    Result := 16;
end;

{ TDoublePoint ^ mm l TPoint ^ Pixel lɕϊ܂B}

function TGraphicPreview.mm2PixelPoint(P: TDoublePoint): TPoint;
begin
  Result := Point(
             Round((P.X - FPaperInfo.TrueMMLeftMargin) / 25.4
                   * FPaperInfo.DPI.cx / FPaperInfo.ScaleFactor * 100),
             Round((P.Y - FPaperInfo.TrueMMTopMargin) / 25.4
                   * FPaperInfo.DPI.cy / FPaperInfo.ScaleFactor * 100));
end;

{ TDoubleRect ^ mm l TRect ^ Pixel lɕϊ܂B}

function TGraphicPreview.mm2PixelRect(R: TDoubleRect): TRect;
begin
  Result := Rect(
             Round((R.Left - FPaperInfo.TrueMMLeftMargin) / 25.4
                   * FPaperInfo.DPI.cx / FPaperInfo.ScaleFactor * 100),
             Round((R.Top - FPaperInfo.TrueMMTopMargin) / 25.4
                   * FPaperInfo.DPI.cy / FPaperInfo.ScaleFactor * 100),
             Round((R.Right - FPaperInfo.TrueMMLeftMargin) / 25.4
                   * FPaperInfo.DPI.cx / FPaperInfo.ScaleFactor * 100),
             Round((R.Bottom - FPaperInfo.TrueMMTopMargin)/ 25.4
                   * FPaperInfo.DPI.cy / FPaperInfo.ScaleFactor * 100));
end;

procedure TGraphicPreview.MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
var
  W, H: Integer;
  CX, CY: Integer;
  dx, dy: Integer;
  mx, my: Integer;
  PR: Integer;
begin
  if FMouseAction = True then
  begin
    W := FPaperInfo.PaperSize.Width + 150;
    H := FPaperInfo.PaperSize.Height + 150;

    { ʏ̍W̍WɕϊB}
    CX := X * 100 div FPreviewRatio * FPaperInfo.DPI.cx div FPaperInfo.SDPI.cx;
    CY := Y * 100 div FPreviewRatio * FPaperInfo.DPI.cy div FPaperInfo.SDPI.cy;

    dx := CX div W;
    dy := CY div H;

    mx := CX mod W;
    my := CY mod H;

    mx := mx - (FPaperInfo.LeftMargin + 50); if mx < 0 then mx := 0;
    my := my - (FPaperInfo.TopMargin + 50); if my < 0 then my := 0;

    CX := dx * FPaperInfo.PrintableArea.Width + mx;
    CY := dy * FPaperInfo.PrintableArea.Height + my;

    if ssDouble in Shift then
      PrintPoint := Point(0, 0) // {ƂfBtHg̏Ԃɖ߂B
    else if Button = mbLeft then
    begin
      if ssCtrl in Shift then // ̔{ 10 % ܂B
      begin
        PR := PrintRatio - 10;
        if PR < 10 then
          PR := 10;
        FPrintMode := pmRatio; // {Ɉ郂[hɂB
        PrintRatio := PR;
      end
      else if ssShift in Shift then // ͈̔͂ 10 % ܂B
      begin
        W := FPrintRect.Right - FPrintRect.Left + 1;
        H := FPrintRect.Bottom - FPrintRect.Top + 1;
        if (W > 16) and (H > 16) then
        begin
          W := W * 90 div 100;
          H := H * 90 div 100;
          FPrintRect.Right := FPrintRect.Left + W - 1;
          FPrintRect.Bottom := FPrintRect.Top + H - 1;
        end;
        PrintRect := PrintRect; // ͈͂Ɉ郂[hɂB
      end
      else if ssAlt in Shift then // vr[̔{ 10 % ܂B
      begin
        PR := PreviewRatio - 10;
        if PR < 10 then
          PR := 10;
        PreviewRatio := PR;
      end
      else
      begin
        if PrintMode = pmRatio then
          PrintPoint := Point(CX, CY)
        else if PrintMode = pmArea then
        begin
          W := FPrintRect.Right - FPrintRect.Left;
          H := FPrintRect.Bottom - FPrintRect.Top;
          PrintRect := Rect(CX, CY, CX + W, CY + H);
        end;
      end;
    end
    else if Button = mbRight then
    begin
      if ssCtrl in Shift then // ̔{ 10 % 傫܂B
      begin
        PR := PrintRatio + 10;
        if PR > 1000 then
          PR := 1000;
        FPrintMode := pmRatio; // {Ɉ郂[hɂB
        PrintRatio := PR;
      end
      else if ssShift in Shift then // ͈̔͂ 10 % 傫܂B
      begin
        W := FPrintRect.Right - FPrintRect.Left + 1;
        H := FPrintRect.Bottom - FPrintRect.Top + 1;
        if (W < 16000) and (H < 16000) then
        begin
          W := W * 110 div 100;
          H := H * 110 div 100;
          FPrintRect.Right := FPrintRect.Left + W - 1;
          FPrintRect.Bottom := FPrintRect.Top + H - 1;
        end;
        PrintRect := PrintRect; // ͈͂Ɉ郂[hɂB
      end
      else if ssAlt in Shift then // vr[̔{ 10 % 傫܂B
      begin
        PR := PreviewRatio + 10;
        if PR > 100 then
          PR := 100;
        PreviewRatio := PR;
      end
      else
      begin
        if CX >= FPrintRect.Left then
          FPrintRect.Right := CX
        else
          FPrintRect.Left := CX;

        if CY >= FPrintRect.Top then
          FPrintRect.Bottom := CY
        else
          FPrintRect.Top := CY;

        PrintRect := PrintRect;
      end;
    end;
  end;

  inherited MouseDown(Button, Shift, X, Y);
end;

{ vr[C[WŃ}EX{^ÃnhĂ΂A}
{ TImage ŋN OnMouseDown Cxg TGraphicPreview ̃Cxg }
{ Ƃ܂B}

procedure TGraphicPreview.MouseDownHandler(Sender: TObject; Button: TMouseButton;
 Shift: TShiftState; X, Y: Integer);
begin
  { TImage ̍W TGraphicPreview ̍Wɕϊ܂B}
  X := TImage(Sender).Left + X;
  Y := TImage(Sender).Top + Y;
  { TGraphicPreview   OnMouseDown Cxg𔭐܂B}
  MouseDown(Button, Shift, X, Y);
end;

{ vr[C[WŃ}EX{^ÃnhĂ΂A}
{ TImage ŋN OnMouseMove Cxg TGraphicPreview ̃Cxg }
{ Ƃ܂B}

procedure TGraphicPreview.MouseMoveHandler(Sender: TObject; Shift: TShiftState;
 X, Y: Integer);
begin
  { TImage ̍W TGraphicPreview ̍Wɕϊ܂B}
  X := TImage(Sender).Left + X;
  Y := TImage(Sender).Top + Y;
  { TGraphicPreview   OnMouseMove Cxg𔭐܂B}
  MouseMove(Shift, X, Y);
end;

{ vr[C[WŃ}EX{^ÃnhĂ΂A}
{ TImage ŋN OnMouseUp Cxg TGraphicPreview ̃Cxg }
{ Ƃ܂B}

procedure TGraphicPreview.MouseUpHandler(Sender: TObject; Button: TMouseButton;
 Shift: TShiftState; X, Y: Integer);
begin
  { TImage ̍W TGraphicPreview ̍Wɕϊ܂B}
  X := TImage(Sender).Left + X;
  Y := TImage(Sender).Top + Y;
  { TGraphicPreview   OnMouseUp Cxg𔭐܂B}
  MouseUp(Button, Shift, X, Y);
end;

{ TPoint ^ Pixel l TDoublePoint ^ mm lɕϊ܂B}

function TGraphicPreview.Pixel2mmPoint(P: TPoint): TDoublePoint;
begin
  Result := DoublePoint(
             FPaperInfo.TrueMMLeftMargin +  P.X / FPaperInfo.DPI.cx
              * 25.4 * FPaperInfo.ScaleFactor / 100,
             FPaperInfo.TrueMMTopMargin +  P.Y / FPaperInfo.DPI.cy
              * 25.4 * FPaperInfo.ScaleFactor / 100);
end;

{ TRect ^ Pixel l TDoubleRect ^ mm lɕϊ܂B}

function TGraphicPreview.Pixel2mmRect(R: TRect): TDoubleRect;
begin
  Result := DoubleRect(
             FPaperInfo.TrueMMLeftMargin + R.Left / FPaperInfo.DPI.cx
              * 25.4 * FPaperInfo.ScaleFactor / 100,
             FPaperInfo.TrueMMTopMargin + R.Top / FPaperInfo.DPI.cy
              * 25.4 * FPaperInfo.ScaleFactor / 100,
             FPaperInfo.TrueMMLeftMargin + R.Right / FPaperInfo.DPI.cx
              * 25.4 * FPaperInfo.ScaleFactor / 100,
             FPaperInfo.TrueMMTopMargin + R.Bottom / FPaperInfo.DPI.cy
              * 25.4 * FPaperInfo.ScaleFactor / 100);
end;

procedure TGraphicPreview.Preview;   // Cxg\bh
begin
  if Assigned(FOnPreview) then
    FOnPreview(Self);  // CxgnȟĂяo
end;

procedure TGraphicPreview.Previewed;   // Cxg\bh
begin
  if Assigned(FOnPreviewed) then
    FOnPreviewed(Self);  // CxgnȟĂяo
end;

procedure TGraphicPreview.Print(Books: Integer);
var
  X, Y, B: Integer;
  R, C: Integer;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  if (FPicture.Graphic = Nil) or (Books < 1) or (Books > 1000) then
    Exit;

  R := Row;
  C := Column;

  if FGraphicMode = gmMetafile then
  begin
    Printer.BeginDoc;
    try
      Mf := TMetafile.Create;
      try
      { OtBbNƓ傫̃^t@CB}
        Mf.Width := FPicture.Graphic.Width
                    * 100 div FPaperInfo.MScaleFactor.cx;
        Mf.Height := FPicture.Graphic.Height
                    * 100 div FPaperInfo.MScaleFactor.cy;
        MfCanvas := TMetafileCanvas.Create(Mf, Printer.Handle);
        try
          MfCanvas.Draw(0, 0, FPicture.Graphic);
        finally
          MfCanvas.Free; // JĂ͂߂ăOtBbN\B
        end;
        for B := 1 to Books do
        begin
          for Y := 1 to R do
          begin
            for X := 1 to C do
            begin
              Printer.Canvas.StretchDraw(PageRect[X, Y], Mf);
              if (X < C) or (Y < R) then
                Printer.NewPage;
            end;
          end;
          if B < Books then
            Printer.NewPage;
        end;
      finally
        Mf.Free;
      end;
    except
      Printer.Abort;
      raise;
    end;
    Printer.EndDoc;
  end
  else if FGraphicMode = gmGraphic then
  begin
    Printer.BeginDoc;
    try
      for B := 1 to Books do
      begin
        for Y := 1 to R do
        begin
          for X := 1 to C do
          begin
            Printer.Canvas.StretchDraw(PageRect[X, Y], FPicture.Graphic);
            if (X < C) or (Y < R) then
              Printer.NewPage;
          end;
        end;
        if B < Books then
          Printer.NewPage;
      end;
    except
      Printer.Abort;
      raise;
    end;
    Printer.EndDoc;
  end;
end;

procedure TGraphicPreview.PrintPage(PageFrom: Integer; PageTo: Integer; Books: Integer);
var
  X, Y, B: Integer;
  R, C: Integer;
  L, N, Count: Integer;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  if (FPicture.Graphic = Nil) or (Books < 1) or (Books > 1000)  then
    Exit;

  R := Row;
  C := Column;

  if (PageFrom < 1) or (PageFrom > PageTo) or (PageTo > R * C) then
    Exit;

  N := PageTo - PageFrom + 1; // P̃y[W

  if FGraphicMode = gmMetafile then
  begin
    Printer.BeginDoc;
    try
      Mf := TMetafile.Create;
      try
      { OtBbNƓ傫̃^t@CB}
        Mf.Width := FPicture.Graphic.Width
                    * 100 div FPaperInfo.MScaleFactor.cx;
        Mf.Height := FPicture.Graphic.Height
                    * 100 div FPaperInfo.MScaleFactor.cy;
        MfCanvas := TMetafileCanvas.Create(Mf, Printer.Handle);
        try
          MfCanvas.Draw(0, 0, FPicture.Graphic);
        finally
          MfCanvas.Free; // JĂ͂߂ăOtBbN\B
        end;
        for B := 1 to Books do
        begin
          Count := 0;
          for Y := 1 to R do
          begin
            for X := 1 to C do
            begin
              L := (Y - 1) * R + X;
              if (L >= PageFrom) and (L <= PageTo) then
              begin
                Printer.Canvas.StretchDraw(PageRect[X, Y], Mf);
                Inc(Count);
                if Count < N then
                  Printer.NewPage;
              end;
            end;
          end;
          if B < Books then
            Printer.NewPage;
        end;
      finally
        Mf.Free;
      end;
    except
      Printer.Abort;
      raise;
    end;
    Printer.EndDoc;
  end
  else if FGraphicMode = gmGraphic then
  begin
    Printer.BeginDoc;
    try
      for B := 1 to Books do
      begin
        Count := 0;
        for Y := 1 to R do
        begin
          for X := 1 to C do
          begin
            L := (Y - 1) * R + X;
            if (L >= PageFrom) and (L <= PageTo) then
            begin
              Printer.Canvas.StretchDraw(PageRect[X, Y], FPicture.Graphic);
              Inc(Count);
              if Count < N then
                Printer.NewPage;
            end;
          end;
        end;
        if B < Books then
          Printer.NewPage;
      end;
    except
      Printer.Abort;
      raise;
    end;
    Printer.EndDoc;
  end;
end;

{ XVāAvr[̍ĕ\܂B}

procedure TGraphicPreview.Repaint;
begin
  CollectPaperInfo; // XVB
  PrintMode := PrintMode; // vr[ĕ\B
  inherited Repaint;
end;

procedure TGraphicPreview.SetGraphic(const Value: TGraphic);
begin
  FPicture.Assign(Value);
  if Value is TMetafile then
  begin
    FPicture.Graphic.Width := FPicture.Graphic.Width * 100 div FMScaleFactor.cx;
    FPicture.Graphic.Height := FPicture.Graphic.Height * 100 div FMScaleFactor.cy;
  end;
  PrintMode := PrintMode; // vr[\B
end;

procedure TGraphicPreview.SetGraphicMode(const Value: TGraphicMode);
begin
  if Value in [gmMetafile, gmGraphic] then
  begin
    FGraphicMode := Value;
    DispPages; // vr[\B
  end;
end;

procedure TGraphicPreview.SetMMPrintPoint(const Value: TDoublePoint);
begin
  PrintPoint := mm2PixelPoint(Value);
end;

procedure TGraphicPreview.SetMMPrintRect(const Value: TDoubleRect);
begin
  PrintRect := mm2PixelRect(Value);
end;

procedure TGraphicPreview.SetMouseAction(const Value: Boolean);
begin
  FMouseAction := Value;
end;

procedure TGraphicPreview.SetPreviewRatio(const Value: Integer);
begin
  if Value in [10..100] then
  begin
    FPreviewRatio := Value;
    DispPages; // vr[\B
  end;
end;

procedure TGraphicPreview.SetPrintMode(const Value: TPrintMode);
begin
  if Value in [pmRatio, pmArea] then
  begin
    if Value = pmRatio then // {Ɉ(Graphic ̏c̔䗦͂̂܂܂)
      MMPrintPoint := MMPrintPoint // vr[\B
    else if Value = pmArea then // ͈͂Ɉ(Graphic ̏c̔䗦Ɋ֌WȂ)
      MMPrintRect := MMPrintRect; // vr[\B
  end;
end;

procedure TGraphicPreview.SetPrintPoint(const Value: TPoint);
var
  W, H: Integer;
begin
  W := 0;
  H := 0;
  FPrintMode := pmRatio; // {Ɉ郂[hɐ؂ւB

  { ȍ~APrintPoint, MMPrintPoint, PrintRect, MMPrintRect }
  {  ̊eupeClm肳܂B}

  FPrintPoint := Value; // Jnn_(sNZP)
  CorrectPoint(FPrintPoint); // FPrintPoint ɗlɕ␳܂B

  FMMPrintPoint := Pixel2mmPoint(FPrintPoint); // Jnn_(mm P)

  if FPicture.Graphic <> Nil then
  begin
    W := FPicture.Graphic.Width * FPaperInfo.DPI.cx * FPrintRatio
         div FPaperInfo.SDPI.cx div 100;
    H := FPicture.Graphic.Height * FPaperInfo.DPI.cy * FPrintRatio
         div FPaperInfo.SDPI.cy div 100;
  end;

  FPrintRect := Rect( // ͈(sNZP)
                     FPrintPoint.X,
                     FPrintPoint.Y,
                     FPrintPoint.X + W - 1,
                     FPrintPoint.Y + H - 1);

  FMMPrintRect := Pixel2mmRect(FPrintRect); // ͈(mm P)

  DispPages; // vr[\B
end;

procedure TGraphicPreview.SetPrintRatio(const Value: Integer);
begin
  if (Value >= 1) and (Value <= 10000) then // 1% ` 10000%(1/100 { ` 100 {)
  begin
    FPrintRatio := Value;
    PrintMode := PrintMode; // vr[\B
  end;
end;

procedure TGraphicPreview.SetPrintRect(const Value: TRect);
begin
  FPrintMode := pmArea; // ͈͂Ɉ郂[hɐ؂ւB

  { ȍ~APrintPoint, MMPrintPoint, PrintRect, MMPrintRect }
  {  ̊eupeClm肳܂B}

  FPrintRect := Value; // ͈(sNZP)
  CorrectRect(FPrintRect); // FPrintRect ̍オɗlɕ␳܂B

  FMMPrintRect := Pixel2mmRect(FPrintRect); // ͈(mm P)

  FPrintPoint := Point(FPrintRect.Left, FPrintRect.Top); // Jnn_(sNZP)

  FMMPrintPoint := Pixel2mmPoint(FPrintPoint); // Jnn_(mm P)

  DispPages; // vr[\B
end;

{ vr[C[WŃ}EX{^ÃnhĂ΂A}
{ TImage ŋN OnStartDock Cxg TGraphicPreview ̃Cxg }
{ Ƃ܂B}

procedure TGraphicPreview.StartDockHandler(Sender: TObject;
 var DragObject: TDragDockObject);
begin
  { TGraphicPreview   OnStartDock Cxg𔭐܂B}
  DoStartDock(TDragObject(DragObject));
end;

{ vr[C[WŃ}EX{^ÃnhĂ΂A}
{ TImage ŋN OnStartDrag Cxg TGraphicPreview ̃Cxg }
{ Ƃ܂B}

procedure TGraphicPreview.StartDragHandler(Sender: TObject;
 var DragObject: TDragObject);
begin
  { TGraphicPreview   OnStartDrag Cxg𔭐܂B}
  DoStartDrag(DragObject);
end;

end.
